<?php

class Authentication extends DBfunctions
{
	// Get the settings from the database and put them into session variables
	function getSettings()
	{
		$_SESSION['authSettingsArray'] = $this->getrow($this->query("SELECT * FROM ".ROSTER_ADDON_AUTHENTICATIONSETTINGSTABLE.""));
		@extract($_SESSION['authSettingsArray']);
			$_SESSION['profileField'] = $profile_field;
			$_SESSION['forumDBprefix'] = $cms_table_prefix;
			$_SESSION['authMessages'] = $auth_messages;
			$_SESSION['separateDB'] = $separate_db;
			$_SESSION['upload_group'] = $opt_upload_group;
			$_SESSION['upload_members_group'] = $opt_upload_members_group;
			$_SESSION['prog_id'] = $opt_prog_id;
			$_SESSION['opt_cookie_prefix'] = $opt_cookie_prefix;
			$_SESSION['cms_name'] = $cms_name;
	}
	
	
	
	function detectCMS()
	{
		if($_COOKIE['RosterUserName'])
		{
			$_SESSION['UserName'] = $_COOKIE['RosterUserName'];
		}else{
			global $IDNames;
			foreach($IDNames as $key => $value){
				if($key == $_SESSION['cms_name']){
					$this->authenticateUser($key);
					return;
				}
			}
			if($_SESSION['authMessages']){
				print "Cannot detect CMS/Forum type, make sure the roster folder is in the CMS/Forum's root/main folder.";
			}
		}
	}
	
	
	function current_dir() 
	{ 
	$path = dirname($_SERVER[PHP_SELF]); 
	$position = strrpos($path,'/') + 1; 
	return substr($path,$position); 
	} 
		
	
	function deleteCookie()
	{
		setcookie("RosterUserName", "", time() - 3600);
	}
	
	
	// Compare the passed in name against the names on the roster
	function checkRoster($name)
	{
		global $db_prefix;
		$authArray = $this->getrow($this->query("SELECT ".$db_prefix."members.name FROM ".$db_prefix."members WHERE ".$db_prefix."members.name = '".$this->escape(ucfirst(strtolower($name)))."'"));
		if($authArray)
		{
			$GLOBALS['rosterUserName'] = $authArray['name'];
			setcookie("RosterUserName", ucfirst(strtolower($authArray['name'])));
			return true;
		}
	}
	
	
	function authenticateUser($CMStype)
	{
		switch ($CMStype)
		{
			case "e107_6":
			{
				$GLOBALS['authenticated_user'] = true;	
				if(defined(USERNAME))
				{
					if(!$this->checkRoster(USERNAME))
					{
						$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."user.user_".$_SESSION['profileField']." FROM ".$_SESSION['forumDBprefix']."user WHERE ".$_SESSION['forumDBprefix']."user.user_name = '".USERNAME."'", $_SESSION['separateDB']));
						if($authArray)
						{
							$this->checkRoster($authArray['user_'.$_SESSION['profileField']]);
						}
					}
				}elseif(!$GLOBALS['rosterUserName']){ 
					if(isset($_REQUEST['ecookie'])) {
						$cookie = $_REQUEST['ecookie'];
					}elseif(isset($_REQUEST['e107cookie'])){
						$cookie = $_REQUEST['e107cookie'];
					} 
					$euser = explode(".", $cookie, 2);
					if($euser[0]){
						$authArray = $this->getrow($this->query("SELECT  ".$_SESSION['forumDBprefix']."user.user_name, ".$_SESSION['forumDBprefix']."user.user_".$_SESSION['profileField']." FROM  ".$_SESSION['forumDBprefix']."user WHERE  ".$_SESSION['forumDBprefix']."user.user_id = ".$euser[0]."", $_SESSION['separateDB'])); 
						if($authArray){
							if(!$this->checkRoster($authArray['user_name']))
							{
								$this->checkRoster($authArray['user_'.$_SESSION['profileField']]);
							}
						}
					}
				}# $userName = USERNAME;
				break;
			}
			case "e107_7":
			{	
				$GLOBALS['authenticated_user'] = true;	
				// The user ID seems to be the first number in this sort of cookie string: 1.696d29e0940a4957748fe3fc9efd22a3
				$e107userID = explode(".", $_REQUEST[$_SESSION['opt_cookie_prefix']]);
				// $e107userID[0] contains the user id
				$authArray = $this->getrow($this->query("SELECT  ".$_SESSION['forumDBprefix']."user.user_name, ".$_SESSION['forumDBprefix']."user.user_loginname, ".$_SESSION['forumDBprefix']."user.user_customtitle, ".$_SESSION['forumDBprefix']."user_extended.user_".$_SESSION['profileField']." FROM  ".$_SESSION['forumDBprefix']."user LEFT JOIN ".$_SESSION['forumDBprefix']."user_extended ON ".$_SESSION['forumDBprefix']."user_extended.user_extended_id = ".intval($e107userID[0])." WHERE ".$_SESSION['forumDBprefix']."user.user_id = ".intval($e107userID[0])."", $_SESSION['separateDB']));
				if($authArray){
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "phpBB":
			{
				// peel the userID out of the weird cookie makeup
				// normal:
				# $phpBBuserID = explode(":", $_REQUEST[$_SESSION['opt_cookie_prefix'].'_data']);
				# $phpBBuserID = explode('"', stripslashes($phpBBuserID[10]));
				// odd:
				# $phpBBuserID = explode("|", $_REQUEST['phpbb2mysql_data']);
				# $phpBBuserID = explode("=", $phpBBuserID[1]);
				// now the userID is in $phpBBuserID[1];
				// how about using the session id instead
				$phpBBuserID = $this->getrow($this->query("SELECT session_user_id AS id FROM ".$_SESSION['forumDBprefix']."sessions WHERE session_id = '".$_REQUEST[$_SESSION['opt_cookie_prefix'].'_sid']."'", $_SESSION['separateDB']));

				// if you're not logged in, there's not gonna be a userID, so dont bother with the rest
				if(empty($phpBBuserID['id'])) break;
				// check if the wow characters mod for phpbb is installed, if not check the username and extra fields for a char name
				if($this->getCount($this->query("SHOW TABLES LIKE '".$_SESSION['forumDBprefix']."characters'"))==1){ 
					$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."characters.name FROM ".$_SESSION['forumDBprefix']."characters WHERE ".$_SESSION['forumDBprefix']."characters.user_ID = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
					if($authArray) {
						if(!$this->checkRoster($authArray['name'])) { 
							$authArray = $this->getrow($this->query("SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
							foreach($authArray as $field => $name){
								if(!empty($name)) $this->checkRoster($name);
							}
						}
					}else{
						$authArray = $this->getrow($this->query("SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
						foreach($authArray as $field => $name){
							if(!empty($name)) $this->checkRoster($name);
						}
					}
				}else{ 
					$authArray = $this->getrow($this->query("SELECT username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$phpBBuserID['id']."", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "nuke":
			{	
				if(!empty($_REQUEST['user'])){ 
					$nukeUserID = explode(":",base64_decode($_REQUEST['user']));
					$nukeUserID = $nukeUserID[0];
					$authArray = $this->getrow($this->query("SELECT name, username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$nukeUserID."", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}elseif(!empty($_REQUEST['admin'])){
					$nukeUserID = explode(":",base64_decode($_REQUEST['admin']));
					$nukeUserID = $nukeUserID[0];
					$authArray = $this->getrow($this->query("SELECT aid, name FROM ".$_SESSION['forumDBprefix']."authors WHERE aid = '".$nukeUserID."'", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "postnuke":
			{	
				$user = $this->getrow($this->query("SELECT session_info.pn_uid FROM ".$_SESSION['forumDBprefix']."session_info WHERE session_info.pn_sessid = '".$_REQUEST['POSTNUKESID']."'", $_SESSION['separateDB']));
				if($user['pn_uid']) 
				{ 
					$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."users.pn_uname, ".$_SESSION['forumDBprefix']."users.pn_name FROM  ".$_SESSION['forumDBprefix']."users WHERE ".$_SESSION['forumDBprefix']."users.pn_uid = '".$user['pn_uid']."'", $_SESSION['separateDB']));
					if(!$this->checkRoster($authArray['pn_uname']))
					{
						if(!$this->checkRoster($authArray['pn_name']))
						{
							$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."users.pn_user_".$_SESSION['profileField']." FROM  ".$_SESSION['forumDBprefix']."users WHERE ".$_SESSION['forumDBprefix']."users.pn_uid = '".$user['pn_uid']."'", $_SESSION['separateDB']));
							if($authArray)
							{
								$this->checkRoster($authArray['pn_user_'.$_SESSION['profileField']]);
							}
						}
					} 
				}
				break;
			}
			case "dragonfly":
			{	
				if(!empty($_REQUEST[$_SESSION['opt_cookie_prefix']])){ 
					$nukeUserID = explode(":",base64_decode($_REQUEST[$_SESSION['opt_cookie_prefix']]));
					$nukeUserID = $nukeUserID[0];
					$authArray = $this->getrow($this->query("SELECT name, username, user_aim, user_yim, user_msnm FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".$nukeUserID."", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "vB":
			{
				$vBuserID = $this->getrow($this->query("SELECT userid FROM ".$_SESSION['forumDBprefix']."session WHERE sessionhash = '".$_REQUEST['bbsessionhash']."'", $_SESSION['separateDB']));
				$authArray = $this->getrow($this->query("SELECT username, icq, aim, yahoo, msn FROM ".$_SESSION['forumDBprefix']."user WHERE userid = ".intval($vBuserID['userid'])."", $_SESSION['separateDB']));
				if($authArray){
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "tikiwiki":
			{	
				$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."sessions.user FROM ".$_SESSION['forumDBprefix']."sessions WHERE ".$_SESSION['forumDBprefix']."sessions.sessionId = '".$_REQUEST['PHPSESSID']."'", $_SESSION['separateDB']));
				if($authArray['user']) 
				{
					if(!$this->checkRoster($authArray['user']))
					{
						if(!$this->checkRoster($authArray['user']))
						{
							$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."user_preferences.value FROM  ".$_SESSION['forumDBprefix']."user_preferences WHERE prefName = 'realName' AND user = '".$authArray['user']."'", $_SESSION['separateDB']));
							if($authArray['value'])
							{
								$this->checkRoster($authArray['value']);
							}
						}
					} 
				} # $userName = $user['user'];
				break;
			}
			case "smf":
			{
				if(!empty($_REQUEST[$_SESSION['opt_cookie_prefix']]))
				{
					$smfUserID = explode(":", $_REQUEST[$_SESSION['opt_cookie_prefix']]);
					$smfUserID = explode('"', stripslashes($smfUserID[5]));
					print $smfUserID[1];
					$authArray = $this->getrow($this->query("SELECT memberName, realName, personalText, ICQ, AIM, YIM, MSN FROM ".$_SESSION['forumDBprefix']."members WHERE ID_MEMBER = ".intval($smfUserID[1])."", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "wbb":
			{
				if(!empty($_REQUEST['wbb_userid']))	{
					$authArray = $this->getrow($this->query("SELECT username, icq, aim, yim, msn FROM ".$_SESSION['forumDBprefix']."users WHERE userid = ".$_REQUEST['wbb_userid']."", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "IPB": 
			{
				if($_SESSION['profileField']=='aim'||empty($_SESSION['profileField'])) $messenger_field = 'aim_name';
				elseif($_SESSION['profileField']=='yim') $messenger_field = 'yahoo';
				elseif($_SESSION['profileField']=='msn') $messenger_field = 'msnname';
				$authArray = $this->getrow($this->query("SELECT sessions.member_id, sessions.member_name, member_extra.".$messenger_field." FROM ".$_SESSION['forumDBprefix']."sessions AS sessions, ".$_SESSION['forumDBprefix']."member_extra AS member_extra, ".$_SESSION['forumDBprefix']."members AS members WHERE sessions.id = '".$_REQUEST[$_SESSION['opt_cookie_prefix'].'session_id']."' AND sessions.member_id = members.id AND sessions.member_id = member_extra.id", $_SESSION['separateDB'])); 

				if($authArray['member_name']){
					if($this->checkRoster($authArray['member_name'])) break;
					elseif($authArray[$messenger_field]){
						if($this->checkRoster($authArray[$messenger_field])) break;
					}
				}
				break;
			}
			// Joomla mixes all session info, md5's it and then writes it into the cookie. 
			// I dont see a way to backtrack in order to get the userID or username from the cookie.
			/* 
			case "joomla":
			{
				if($_COOKIE['usercookie']['username']){
					if(!$this->checkRoster($_COOKIE['usercookie']['username']))
					{
						$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."users.name FROM  ".$_SESSION['forumDBprefix']."users WHERE ".$_SESSION['forumDBprefix']."users.username = '".$_COOKIE['usercookie']['username']."'", $_SESSION['separateDB']));
						if($authArray)
						{
							$this->checkRoster($authArray['user_'.$_SESSION['profileField']]);
						}
					}
				}# $userName = $_COOKIE['usercookie']['username'];
				break;
			} 
			*/
			case "unb":
			{
				//$_SESSION['prog_id'] = 'unb472';	
				// In your unb board config section go to "Security" and read the "Program ID", that value has to be put in here.
				if($_COOKIE[$_SESSION['prog_id'].'-CUserID'])
				{
					$authArray = $this->getrow($this->query("SELECT ".$_SESSION['forumDBprefix']."users.name, ".$_SESSION['forumDBprefix']."users.".strtoupper($_SESSION['profileField'])." FROM ".$_SESSION['forumDBprefix']."users WHERE ".$_SESSION['forumDBprefix']."users.ID = ".$_COOKIE[$_SESSION['prog_id'].'-CUserID']."", $_SESSION['separateDB']));
					if($authArray)
					{
						if(!$this->checkRoster($authArray['Name']))
						{
							$this->checkRoster($authArray[strtoupper($_SESSION['profileField'])]);
						}
					}
				}# $_COOKIE[$_SESSION['prog_id'].'-CUserID'];
				break;
			}
			case "phpfusion":
			{	
				if ($_COOKIE['fusion_user']) {
					$cookie_vars = explode(".", $_COOKIE['fusion_user']);
					$authArray = $this->getrow($this->query("SELECT user_name, user_aim, user_icq, user_msn, user_yahoo FROM ".$_SESSION['forumDBprefix']."users WHERE user_id = ".intval($cookie_vars[0])."", $_SESSION['separateDB']));
					foreach($authArray as $field => $name){
						if(!empty($name)) $this->checkRoster($name);
					}
				}
				break;
			}
			case "minibb":
			{// $cookiename='miniBBsite'; $cookiepath='/'; in setup_options.php
				$miniBBcookie = explode("|", $_REQUEST['miniBBsite']);
				$authArray = $this->getrow($this->query("SELECT username, user_icq FROM ".$_SESSION['forumDBprefix']."users WHERE username = '".$miniBBcookie[0]."'", $_SESSION['separateDB']));
				if($authArray){
					if(!$this->checkRoster($authArray['username'])){
						$this->checkRoster($authArray['user_icq']);
					}
				}
				break;
			}
		}
		if(!$GLOBALS['rosterUserName']){
			if($_SESSION['authMessages']){
				if((!isset($php_userid))||($php_userid!==0)){
					print "Roster Authentication failed";
				}
			}
		}else{
			if(!$_COOKIE['RosterUserName']){
				$_SESSION['UserName'] = ucfirst(strtolower($GLOBALS['rosterUserName']));
			} else {
				$_SESSION['UserName'] = $_COOKIE['RosterUserName'];
			}
		}
	}
}
$Authentication = new Authentication();
$Authentication->getSettings();
$Authentication->detectCMS();

?>